/*
 * Derived class of Conversions
 *
 */

package eetoolbelt;

/**
 *
 * @author Anthony Lemaster
 */
public class Radix extends Conversions {

    /* Attributes */
    private String[] radixDataList = {"Hexadecimal","Decimal","Octal","Binary"};

    /* Class Constructor */
    public Radix() {
        super("Number Base Conversions");
    }

    /* Methods */
    @Override
    public String[] GetDataList() {
        return radixDataList;
    }
    @Override
    public String Convert()
    {

        /* To Hexadecimal */
        if (toIndex == 0 && fromIndex == 0)
        {
            output = H2H();
        }
        else if (toIndex == 0 && fromIndex == 1)
        {
            output = D2H();
        }
        else if (toIndex == 0 && fromIndex == 2)
        {
            output = O2H();
        }
        else if (toIndex == 0 && fromIndex == 3)
        {
            output = B2H();
        }
        /* To Decimal */
        else if (toIndex == 1 && fromIndex == 0)
        {
            output = H2D();
        }
        else if (toIndex == 1 && fromIndex == 1)
        {
            output = D2D();
        }
        else if (toIndex == 1 && fromIndex == 2)
        {
            output = O2D();
        }
        else if (toIndex == 1 && fromIndex == 3)
        {
            output = B2D();
        }
        /* To Octal */
        else if (toIndex == 2 && fromIndex == 0)
        {
            output = H2O();
        }
        else if (toIndex == 2 && fromIndex == 1)
        {
            output = D2O();
        }
        else if (toIndex == 2 && fromIndex == 2)
        {
            output = O2O();
        }
        else if (toIndex == 2 && fromIndex == 3)
        {
            output = B2O();
        }
        /* To Binary */
        else if (toIndex == 3 && fromIndex == 0)
        {
            output = H2B();
        }
        else if (toIndex == 3 && fromIndex == 1)
        {
            output = D2B();
        }
        else if (toIndex == 3 && fromIndex == 2)
        {
            output = O2B();
        }
        else if (toIndex == 3 && fromIndex == 3)
        {
            output = B2B();
        }
        return output;
    }
    /* To Hexadecimal Methods */
    String H2H () {
        return input;
    }
    String D2H () {
        return Integer.toHexString(Integer.parseInt(input, 10));
    }
    String O2H () {
        return Integer.toHexString(Integer.parseInt(input, 8));
    }
    String B2H () {
        return Integer.toHexString(Integer.parseInt(input, 2));
    }
    /* To Decimal Methods */
    String H2D () {
        return String.valueOf(Integer.parseInt(input, 16));
    }
    String D2D () {
        return input;
    }
    String O2D () {
        return String.valueOf(Integer.parseInt(input, 8));
    }
    String B2D () {
        return String.valueOf(Integer.parseInt(input, 2));
    }
    /* To Octal Methods */
    String H2O () {
        return Integer.toOctalString(Integer.parseInt(input, 16));
    }
    String D2O () {
        return Integer.toOctalString(Integer.parseInt(input, 10));
    }
    String O2O () {
        return input;
    }
    String B2O () {
        return Integer.toOctalString(Integer.parseInt(input, 2));
    }
    /* To Binary Methods */
    String H2B () {
        return Integer.toBinaryString(Integer.parseInt(input, 16));
    }
    String D2B () {
        return Integer.toBinaryString(Integer.parseInt(input, 10));
    }
    String O2B () {
        return Integer.toBinaryString(Integer.parseInt(input, 18));
    }
    String B2B () {
        return input;
    }
}
