/*
 * Derived class of Conversions
 * 
 */

package eetoolbelt;

/**
 *
 * @author Anthony Lemaster
 */
public class Temperature extends Conversions {

    /* Attributes */
    private String[] tempDataList = {"Celsius","Fahrenheit","Kelvin","Rankine"};
    private double dblInput;
    private double dblOutput;

    /* Class Constructor */
    public Temperature() {
        super("Temperature Conversions");
    }

    /* Methods */
    @Override
    public String[] GetDataList() {
        return tempDataList;
    }
    @Override
    public String Convert()
    {
        dblInput = Double.valueOf(input);
        /* To Celsius */
        if (toIndex == 0 && fromIndex == 0)
        {
            dblOutput = C2C();
        }
        else if (toIndex == 0 && fromIndex == 1)
        {
            dblOutput = F2C();
        }
        else if (toIndex == 0 && fromIndex == 2)
        {
            dblOutput = K2C();
        }
        else if (toIndex == 0 && fromIndex == 3)
        {
            dblOutput = R2C();
        }
        /* To Fahrenheit */
        else if (toIndex == 1 && fromIndex == 0)
        {
            dblOutput = C2F();
        }
        else if (toIndex == 1 && fromIndex == 1)
        {
            dblOutput = F2F();
        }
        else if (toIndex == 1 && fromIndex == 2)
        {
            dblOutput = K2F();
        }
        else if (toIndex == 1 && fromIndex == 3)
        {
            dblOutput = R2F();
        }
        /* To Kelvin */
        else if (toIndex == 2 && fromIndex == 0)
        {
            dblOutput = C2K();
        }
        else if (toIndex == 2 && fromIndex == 1)
        {
            dblOutput = F2K();
        }
        else if (toIndex == 2 && fromIndex == 2)
        {
            dblOutput = K2K();
        }
        else if (toIndex == 2 && fromIndex == 3)
        {
            dblOutput = R2K();
        }
        /* To Rankine */
        else if (toIndex == 3 && fromIndex == 0)
        {
            dblOutput = C2R();
        }
        else if (toIndex == 3 && fromIndex == 1)
        {
            dblOutput = F2R();
        }
        else if (toIndex == 3 && fromIndex == 2)
        {
            dblOutput = K2R();
        }
        else if (toIndex == 3 && fromIndex == 3)
        {
            dblOutput = R2R();
        }
        output = String.format("%." + precision + "f", dblOutput); //Formatted for 3 after decimal point
        return output;
    }
    /* To Celsius Methods */
    double C2C () {
        return dblInput;
    }
    double F2C () {
        return ((dblInput - 32) * 0.5555555556);  // C = (F - 32) x 5/9
    }
    double K2C () {
        return (dblInput - 273.15);  // C = K - 273.15
    }
    double R2C () {
        return (dblInput - 491.67) * 0.5555555556;  // C = (R - 491.67) * 5/9
    }
    /* To Fahrenheit Methods */
    double C2F () {
        return ((dblInput * 1.8) + 32);  // F = (C x 9/5) + 32
    }
    double F2F () {
        return dblInput;
    }
    double K2F () {
        return (dblInput * 1.8) - 459.67; // F = (K x 9/5) - 459.67
    }
    double R2F () {
        return dblInput - 459.67; // F = R - 459.67
    }
    /* To Kelvin Methods */
    double C2K () {
        return (dblInput + 273.15);  // K = C + 273
    }
    double F2K () {
        return (dblInput + 459.67) * 0.5555555556;  // K = (F + 459.67) x 5/9
    }
    double K2K () {
        return dblInput;
    }
    double R2K () {
        return dblInput * 0.5555555556; // K = R * 5/9
    }
    /* To Rankine Methods */
    double C2R () {
        return (dblInput + 273.15) * 1.8;  // R = (C + 273.15) x 9/5
    }
    double F2R () {
        return (dblInput + 459.67);  // R = F + 459.67
    }
    double K2R () {
        return dblInput * 1.8; // R = K * 9/5
    }
    double R2R () {
        return dblInput;
    }
}
